diff --git a/database/seeds/CountriesSeeder.php b/database/seeds/CountriesSeeder.php
index 946a5a8..021f57a 100644
--- a/database/seeds/CountriesSeeder.php
+++ b/database/seeds/CountriesSeeder.php
@@ -2,8 +2,8 @@
 
 use Illuminate\Database\Seeder;
 
-class CountriesSeeder extends Seeder {
-
+class CountriesSeeder extends Seeder
+{
     /**
      * Run the database seeds.
      *
@@ -13,7 +13,7 @@ class CountriesSeeder extends Seeder {
     {
         //Get all of the countries
         $countries = Countries::getList();
-        foreach ($countries as $countryId => $country){
+        foreach ($countries as $countryId => $country) {
             DB::table('countries')->insert(array(
                 'id' => $countryId,
                 'capital' => ((isset($country['capital'])) ? $country['capital'] : null),
diff --git a/public/.htaccess b/public/.htaccess
index 5716f17..2e0b3d9 100644
--- a/public/.htaccess
+++ b/public/.htaccess
@@ -13,4 +13,8 @@
     RewriteCond %{REQUEST_FILENAME} !-d
     RewriteCond %{REQUEST_FILENAME} !-f
     RewriteRule ^ index.php [L]
+
+    # Handle Authorization Header
+    RewriteCond %{HTTP:Authorization} .
+    RewriteRule .* - [E=HTTP_AUTHORIZATION:%{HTTP:Authorization}]
 </IfModule>
diff --git a/resources/lang/de/app.php b/resources/lang/de/app.php
index ada8f49..c172fae 100644
--- a/resources/lang/de/app.php
+++ b/resources/lang/de/app.php
@@ -62,6 +62,7 @@ return [
     'i_forgot_my_password' => 'Passwort vergessen?',
     'remember_me' => 'Anmeldedaten merken?',
     'dont_have_an_account' => 'Sie haben noch keinen Account?',
+    'register' => 'Registrieren',
 
     'email' => 'eMail',
     'your_email' => 'Ihre eMail-Adresse',
diff --git a/resources/lang/en/app.php b/resources/lang/en/app.php
index 4127a63..e40fe94 100644
--- a/resources/lang/en/app.php
+++ b/resources/lang/en/app.php
@@ -62,6 +62,7 @@ return [
     'i_forgot_my_password' => 'I forgot my password',
     'remember_me' => 'Remember me?',
     'dont_have_an_account' => 'Don\'t have an account?',
+    'register' => 'Register',
 
     'email' => 'Email',
     'your_email' => 'Your E-Mail',
@@ -198,7 +199,6 @@ return [
     'edit_user' => 'Edit User',
     'edit_user_details' => 'edit user details',
     'details' => 'Details',
-    'social_networks' => 'Social Networks',
     'list_of_registered_users' => 'list of registered users',
     'search_for_users' => 'Search for users...',
     'full_name' => 'Full Name',
@@ -248,7 +248,6 @@ return [
     'phone' => 'Phone',
     'address' => 'Address',
     'country' => 'Country',
-    'update_social_networks' => 'Update Social Networks',
     'in_order_to_enable_2fa_you_must' => 'In order to enable Two-Factor Authentication, you must install',
     'application_on_your_phone' => 'application on your phone',
     'country_code' => 'Country Code',
@@ -273,7 +272,6 @@ return [
 
     'profile_updated_successfully' => 'Profile updated successfully.',
     'avatar_changed' => 'Avatar changed successfully.',
-    'socials_updated' => 'Social networks updated successfully.',
     'login_updated' => 'Login details updated successfully.',
     '2fa_already_enabled' => 'Two-Factor Authentication is already enabled.',
     '2fa_enabled' => 'Two-Factor Authentication enabled successfully.',
diff --git a/resources/lang/en/validation.php b/resources/lang/en/validation.php
index c7a1ecf..812437c 100644
--- a/resources/lang/en/validation.php
+++ b/resources/lang/en/validation.php
@@ -75,6 +75,7 @@ return [
     'timezone'             => 'The :attribute must be a valid zone.',
     'unique'               => 'The :attribute has already been taken.',
     'url'                  => 'The :attribute format is invalid.',
+    'captcha'              => 'reCAPTCHA value is invalid.',
 
     /*
     |--------------------------------------------------------------------------
diff --git a/resources/lang/sr/app.php b/resources/lang/sr/app.php
index 98a0cd8..c80b5cd 100644
--- a/resources/lang/sr/app.php
+++ b/resources/lang/sr/app.php
@@ -60,6 +60,7 @@ return [
     'i_forgot_my_password' => 'Zaboravio sam lozinku',
     'remember_me' => 'Zapamti me',
     'dont_have_an_account' => 'Nemate nalog?',
+    'register' => 'Kreiraj nalog',
 
     'email' => 'E-Adresa',
     'your_email' => 'Vaša E-Adresa',
diff --git a/resources/views/auth/register.blade.php b/resources/views/auth/register.blade.php
index 1024a89..c0c85a8 100644
--- a/resources/views/auth/register.blade.php
+++ b/resources/views/auth/register.blade.php
@@ -55,7 +55,7 @@
 
             <div class="form-group">
                 <button type="submit" class="btn btn-custom btn-lg btn-block" id="btn-login">
-                    Register
+                    @lang('app.register')
                 </button>
             </div>
         </form>
diff --git a/resources/views/partials/sidebar.blade.php b/resources/views/partials/sidebar.blade.php
index 52e57e7..16b10cd 100644
--- a/resources/views/partials/sidebar.blade.php
+++ b/resources/views/partials/sidebar.blade.php
@@ -55,7 +55,7 @@
                 </li>
             @endpermission
 
-            @permission(['settings.general', 'settings.auth', 'settings.notifications'])
+            @permission(['settings.general', 'settings.auth', 'settings.notifications'], false)
             <li class="{{ Request::is('settings*') ? 'active open' : ''  }}">
                 <a href="#">
                     <i class="fa fa-gear fa-fw"></i> @lang('app.settings')
diff --git a/resources/views/user/edit.blade.php b/resources/views/user/edit.blade.php
index 91ddae5..5747cef 100644
--- a/resources/views/user/edit.blade.php
+++ b/resources/views/user/edit.blade.php
@@ -32,12 +32,6 @@
         </a>
     </li>
     <li role="presentation">
-        <a href="#social-networks" aria-controls="social-networks" role="tab" data-toggle="tab">
-            <i class="fa fa-youtube"></i>
-            @lang('app.social_networks')
-        </a>
-    </li>
-    <li role="presentation">
         <a href="#auth" aria-controls="auth" role="tab" data-toggle="tab">
             <i class="fa fa-lock"></i>
             @lang('app.authentication')
@@ -61,15 +55,6 @@
             </div>
         </div>
     </div>
-    <div role="tabpanel" class="tab-pane" id="social-networks">
-        <div class="row">
-            <div class="col-md-12">
-                {!! Form::open(['route' => ['user.update.socials', $user->id]]) !!}
-                    @include('user.partials.social-networks')
-                {!! Form::close() !!}
-            </div>
-        </div>
-    </div>
     <div role="tabpanel" class="tab-pane" id="auth">
         <div class="row">
             <div class="col-md-8">
diff --git a/resources/views/user/partials/details.blade.php b/resources/views/user/partials/details.blade.php
index 5066b50..f13d0ea 100644
--- a/resources/views/user/partials/details.blade.php
+++ b/resources/views/user/partials/details.blade.php
@@ -5,8 +5,8 @@
             <div class="col-md-6">
                 <div class="form-group">
                     <label for="first_name">@lang('app.role')</label>
-                    {!! Form::select('role', $roles, $edit ? $user->role->id : '',
-                        ['class' => 'form-control', 'id' => 'role', $profile ? 'disabled' : '']) !!}
+                    {!! Form::select('role_id', $roles, $edit ? $user->role->id : '',
+                        ['class' => 'form-control', 'id' => 'role_id', $profile ? 'disabled' : '']) !!}
                 </div>
                 <div class="form-group">
                     <label for="status">@lang('app.status')</label>
diff --git a/resources/views/user/profile.blade.php b/resources/views/user/profile.blade.php
index 9a1fdb5..ff23ad6 100644
--- a/resources/views/user/profile.blade.php
+++ b/resources/views/user/profile.blade.php
@@ -30,12 +30,6 @@
         </a>
     </li>
     <li role="presentation">
-        <a href="#social-networks" aria-controls="social-networks" role="tab" data-toggle="tab">
-            <i class="fa fa-youtube"></i>
-            @lang('app.social_networks')
-        </a>
-    </li>
-    <li role="presentation">
         <a href="#auth" aria-controls="auth" role="tab" data-toggle="tab">
             <i class="fa fa-lock"></i>
             @lang('app.authentication')
@@ -59,15 +53,6 @@
             </div>
         </div>
     </div>
-    <div role="tabpanel" class="tab-pane" id="social-networks">
-        <div class="row">
-            <div class="col-md-12">
-                {!! Form::open(['route' => 'profile.update.social-networks', 'method' => 'PUT', 'id' => 'socials-form']) !!}
-                    @include('user.partials.social-networks')
-                {!! Form::close() !!}
-            </div>
-        </div>
-    </div>
     <div role="tabpanel" class="tab-pane" id="auth">
         <div class="row">
             <div class="col-md-8">
diff --git a/resources/views/user/view.blade.php b/resources/views/user/view.blade.php
index 462ae48..6f8a588 100644
--- a/resources/views/user/view.blade.php
+++ b/resources/views/user/view.blade.php
@@ -39,46 +39,6 @@
                 </div>
                 <div class="name"><strong>{{ $user->present()->name }}</strong></div>
 
-                @if ($socialNetworks)
-                    <div class="icons">
-                        @if ($socialNetworks->facebook)
-                            <a href="{{ $socialNetworks->facebook }}" class="btn btn-circle btn-facebook">
-                                <i class="fa fa-facebook"></i>
-                            </a>
-                        @endif
-
-                        @if ($socialNetworks->twitter)
-                            <a href="{{ $socialNetworks->twitter }}" class="btn btn-circle btn-twitter">
-                                <i class="fa fa-twitter"></i>
-                            </a>
-                        @endif
-
-                        @if ($socialNetworks->google_plus)
-                            <a href="{{ $socialNetworks->google_plus }}" class="btn btn-circle btn-google">
-                                <i class="fa fa-google-plus"></i>
-                            </a>
-                        @endif
-
-                        @if ($socialNetworks->linked_in)
-                            <a href="{{ $socialNetworks->linked_in }}" class="btn btn-circle btn-linkedin">
-                                <i class="fa fa-linkedin"></i>
-                            </a>
-                        @endif
-
-                        @if ($socialNetworks->skype)
-                            <a href="{{ $socialNetworks->skype }}" class="btn btn-skype">
-                                <i class="fa fa-skype"></i>
-                            </a>
-                        @endif
-
-                        @if ($socialNetworks->dribbble)
-                            <a href="{{ $socialNetworks->dribbble }}" class="btn btn-circle btn-dribbble">
-                                <i class="fa fa-dribbble"></i>
-                            </a>
-                        @endif
-                    </div>
-                @endif
-
                 <br>
 
                 <table class="table table-hover table-details">
@@ -98,13 +58,6 @@
                                 <td><a href="telto:{{ $user->phone }}">{{ $user->phone }}</a></td>
                             </tr>
                         @endif
-
-                        @if ($socialNetworks && $socialNetworks->skype)
-                            <tr>
-                                <td>Skype</td>
-                                <td>{{ $socialNetworks->skype }}</td>
-                            </tr>
-                        @endif
                     </tbody>
                 </table>
 
diff --git a/routes/api.php b/routes/api.php
index 51535fb..fa3a692 100644
--- a/routes/api.php
+++ b/routes/api.php
@@ -1,12 +1,64 @@
 <?php
 
-/*
-|--------------------------------------------------------------------------
-| API Routes
-|--------------------------------------------------------------------------
-|
-| Here is where you can register API routes for your application. These
-| routes are loaded by the RouteServiceProvider within a group which
-| is assigned the "api" middleware group. Enjoy building your API!
-|
-*/
+Route::post('login', 'Auth\AuthController@login');
+Route::post('login/social', 'Auth\SocialLoginController@index');
+Route::post('logout', 'Auth\AuthController@logout');
+
+if (settings('reg_enabled')) {
+    Route::post('register', 'Auth\RegistrationController@index');
+    Route::post('register/verify-email/{token}', 'Auth\RegistrationController@verifyEmail');
+}
+
+if (settings('forgot_password')) {
+    Route::post('password/remind', 'Auth\Password\RemindController@index');
+    Route::post('password/reset', 'Auth\Password\ResetController@index');
+}
+
+Route::get('stats', 'StatsController@index');
+
+Route::get('me', 'Profile\DetailsController@index');
+Route::patch('me/details', 'Profile\DetailsController@update');
+Route::put('me/avatar', 'Profile\AvatarController@update');
+Route::delete('me/avatar', 'Profile\AvatarController@destroy');
+Route::put('me/avatar/external', 'Profile\AvatarController@updateExternal');
+Route::get('me/sessions', 'Profile\SessionsController@index');
+
+if (settings('2fa.enabled')) {
+    Route::put('me/2fa', 'Profile\TwoFactorController@update');
+    Route::delete('me/2fa', 'Profile\TwoFactorController@destroy');
+}
+
+Route::resource('users', 'Users\UsersController', [
+    'except' => 'create'
+]);
+
+Route::put('users/{user}/avatar', 'Users\AvatarController@update');
+Route::put('users/{user}/avatar/external', 'Users\AvatarController@updateExternal');
+Route::delete('users/{user}/avatar', 'Users\AvatarController@destroy');
+
+if (settings('2fa.enabled')) {
+    Route::put('users/{user}/2fa', 'Users\TwoFactorController@update');
+    Route::delete('users/{user}/2fa', 'Users\TwoFactorController@destroy');
+}
+
+Route::get('users/{user}/activity', 'Users\ActivityController@index');
+Route::get('users/{user}/sessions', 'Users\SessionsController@index');
+
+Route::get('/sessions/{session}', 'SessionsController@show');
+Route::delete('/sessions/{session}', 'SessionsController@destroy');
+
+Route::get('/activity', 'ActivityController@index');
+
+Route::resource('roles', 'Authorization\RolesController', [
+    'except' => 'create'
+]);
+Route::get("roles/{role}/permissions", 'Authorization\RolePermissionsController@show');
+Route::put("roles/{role}/permissions", 'Authorization\RolePermissionsController@update');
+
+Route::resource('permissions', 'Authorization\PermissionsController', [
+    'except' => 'create'
+]);
+
+Route::get('/settings', 'SettingsController@index');
+
+Route::get('/countries', 'CountriesController@index');
diff --git a/routes/web.php b/routes/web.php
index 49513eb..0de3bd8 100644
--- a/routes/web.php
+++ b/routes/web.php
@@ -104,11 +104,6 @@ Route::group(['middleware' => 'auth'], function () {
         'uses' => 'ProfileController@updateLoginDetails'
     ]);
 
-    Route::put('profile/social-networks/update', [
-        'as' => 'profile.update.social-networks',
-        'uses' => 'ProfileController@updateSocialNetworks'
-    ]);
-
     Route::post('profile/two-factor/enable', [
         'as' => 'profile.two-factor.enable',
         'uses' => 'ProfileController@enableTwoFactorAuth'
@@ -182,11 +177,6 @@ Route::group(['middleware' => 'auth'], function () {
         'uses' => 'UsersController@updateAvatarExternal'
     ]);
 
-    Route::post('user/{user}/update/social-networks', [
-        'as' => 'user.update.socials',
-        'uses' => 'UsersController@updateSocialNetworks'
-    ]);
-
     Route::get('user/{user}/sessions', [
         'as' => 'user.sessions',
         'uses' => 'UsersController@sessions'
diff --git a/tests/Feature/ApiTestCase.php b/tests/Feature/ApiTestCase.php
new file mode 100644
index 0000000..7d3f5e2
--- /dev/null
+++ b/tests/Feature/ApiTestCase.php
@@ -0,0 +1,76 @@
+<?php
+
+namespace Tests\Feature;
+
+use Illuminate\Support\Collection;
+use Portal\User;
+
+class ApiTestCase extends FunctionalTestCase
+{
+    public function setUp()
+    {
+        putenv("EXPOSE_API=true");
+
+        parent::setUp();
+    }
+
+    /**
+     * @return mixed
+     */
+    protected function login()
+    {
+        $user = factory(User::class)->create();
+
+        $this->be($user, 'api');
+
+        return $user;
+    }
+
+    /**
+     * @return mixed
+     */
+    protected function loginSuperUser()
+    {
+        $user = $this->createSuperUser();
+
+        $this->be($user, 'api');
+
+        return $user;
+    }
+
+    /**
+     * Transform provided collection of items.
+     * @param Collection $collection
+     * @param $transformer
+     * @return array
+     */
+    protected function transformCollection(Collection $collection, $transformer)
+    {
+        $transformed = [];
+
+        foreach ($collection as $item) {
+            $transformed[] = $transformer->transform($item);
+        }
+
+        return $transformed;
+    }
+
+    /**
+     * Check if JWT token in response contains
+     * specified jti claim.
+     * @param $jti
+     * @return $this
+     */
+    protected function assertJwtTokenContains($jti)
+    {
+        $response = $this->decodeResponseJson();
+
+        $parts = explode(".", $response['token']);
+
+        $claims = json_decode(base64_decode($parts[1]));
+
+        $this->assertEquals($jti, $claims->jti);
+
+        return $this;
+    }
+}
diff --git a/tests/Feature/FunctionalTestCase.php b/tests/Feature/FunctionalTestCase.php
index 58caf0d..a6e76c4 100644
--- a/tests/Feature/FunctionalTestCase.php
+++ b/tests/Feature/FunctionalTestCase.php
@@ -6,6 +6,7 @@ use DB;
 use Schema;
 use Settings;
 use Tests\TestCase;
+use Portal\Permission;
 use Portal\Role;
 use Portal\User;
 use Mockery as m;
@@ -72,31 +73,33 @@ class FunctionalTestCase extends TestCase
     }
 
     /**
-     * @param array $attrubutes
+     * @param array $attributes
+     * @param null $guard
      * @return mixed
      */
-    protected function createAndLoginUser(array $attrubutes = [])
+    protected function createAndLoginUser(array $attributes = [], $guard = null)
     {
-        $user = $this->createUserWithSocialNetworks($attrubutes);
+        $user = $this->createUser($attributes);
 
         $user = $this->setRoleForUser($user, 'User');
 
-        $this->be($user);
+        $this->be($user, $guard);
 
         return $user;
     }
 
     /**
-     * @param array $attrubutes
+     * @param array $attributes
+     * @param null $guard
      * @return mixed
      */
-    protected function createAndLoginAdminUser(array $attrubutes = [])
+    protected function createAndLoginAdminUser(array $attributes = [], $guard = null)
     {
-        $user = $this->createUserWithSocialNetworks($attrubutes);
+        $user = $this->createUser($attributes);
 
         $user = $this->setRoleForUser($user, 'Admin');
 
-        $this->be($user);
+        $this->be($user, $guard);
 
         return $user;
     }
@@ -105,12 +108,9 @@ class FunctionalTestCase extends TestCase
      * @param array $attributes
      * @return mixed
      */
-    protected function createUserWithSocialNetworks(array $attributes = [])
+    protected function createUser(array $attributes = [])
     {
-        $user = factory(User::class)->create($attributes);
-        $user->socialNetworks()->create([]);
-
-        return $user;
+        return factory(User::class)->create($attributes);
     }
 
     /**
@@ -143,6 +143,20 @@ class FunctionalTestCase extends TestCase
         return $user;
     }
 
+    /**
+     * @param User $user
+     * @param $permission
+     */
+    public function addPermissionForUser(User $user, $permission)
+    {
+        $permissions = (array) $permission;
+
+        foreach ($permissions as $perm) {
+            $permObj = Permission::firstOrCreate(['name' => $perm]);
+            $user->role->attachPermission($permObj);
+        }
+    }
+
     public function seeInTable($selector, $text, $rowNumber, $columnNumber, $negate = false)
     {
         $fullSelector = "{$selector} tbody tr:nth-child({$rowNumber}) > td:nth-child({$columnNumber})";
@@ -165,4 +179,13 @@ class FunctionalTestCase extends TestCase
         $link = $this->crawler->filter($selector)->first();
         return $this->visit($link->link()->getUri());
     }
+
+    protected function refreshApp()
+    {
+        $this->refreshApplication();
+
+        if ($this->isSQLiteConnection()) {
+            $this->executeCallbacks();
+        }
+    }
 }
diff --git a/tests/Feature/Http/Controllers/Api/ActivityControllerTest.php b/tests/Feature/Http/Controllers/Api/ActivityControllerTest.php
new file mode 100644
index 0000000..9a87438
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/ActivityControllerTest.php
@@ -0,0 +1,118 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api;
+
+use Tests\Feature\ApiTestCase;
+use Portal\Services\Logging\UserActivity\Activity;
+use Portal\Transformers\ActivityTransformer;
+use Portal\User;
+
+class ActivityControllerTest extends ApiTestCase
+{
+    public function test_unauthenticated()
+    {
+        $this->getJson('/api/activity')
+            ->assertResponseStatus(401);
+    }
+
+    public function test_get_activities_without_permission()
+    {
+        $user = factory(User::class)->create();
+
+        $this->actingAs($user, 'api')
+            ->getJson('/api/activity')
+            ->assertResponseStatus(403);
+    }
+
+    public function test_paginate_activities()
+    {
+        $user = $this->getUser();
+        $user2 = factory(User::class)->create();
+
+        $activities = factory(Activity::class)->times(25)->create([
+            'user_id' => $user->id
+        ]);
+
+        factory(Activity::class)->times(10)->create([
+            'user_id' => $user2->id
+        ]);
+
+        $this->getJson("/api/activity");
+
+        $transformed = $this->transformCollection(
+            $activities->take(20),
+            new ActivityTransformer
+        );
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertEquals($response['data'], $transformed);
+        $this->assertEquals($response['meta'], [
+            'current_page' => 1,
+            'from' => 1,
+            'to' => 20,
+            'last_page' => 2,
+            'prev_page_url' => null,
+            'next_page_url' => url("api/activity?page=2"),
+            'total' => 35,
+            'per_page' => 20
+        ]);
+    }
+
+    public function test_paginate_activities_with_search_param()
+    {
+        $user = $this->getUser();
+
+        $set1 = factory(Activity::class)->times(10)->create([
+            'user_id' => $user->id,
+            'description' => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit.'
+        ]);
+
+        $set2 = factory(Activity::class)->times(5)->create([
+            'user_id' => $user->id,
+            'description' => 'Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris...'
+        ]);
+
+        $transformed = $this->transformCollection(
+            $set2,
+            new ActivityTransformer
+        );
+
+        $this->getJson("/api/activity?search=minim&per_page=10");
+
+        $response = $this->decodeResponseJson();
+
+        $this->assertEquals($response['data'], $transformed);
+        $this->assertEquals($response['meta'], [
+            'current_page' => 1,
+            'from' => 1,
+            'to' => 5,
+            'last_page' => 1,
+            'prev_page_url' => null,
+            'next_page_url' => null,
+            'total' => 5,
+            'per_page' => 10
+        ]);
+    }
+
+    public function test_paginate_activities_with_more_records_per_page_than_allowed()
+    {
+        $user = $this->getUser();
+
+        $this->getJson("/api/activity?per_page=140");
+
+        $this->seeStatusCode(422);
+    }
+
+    /**
+     * @return mixed
+     */
+    private function getUser()
+    {
+        $user = $this->login();
+
+        $this->addPermissionForUser($user, 'users.activity');
+
+        return $user;
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Auth/AuthControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/AuthControllerTest.php
new file mode 100644
index 0000000..c01fc31
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Auth/AuthControllerTest.php
@@ -0,0 +1,99 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Auth;
+
+use Carbon\Carbon;
+use Tests\Feature\ApiTestCase;
+use Tests\MailTrap;
+use Portal\Services\Auth\Api\Token;
+use Portal\User;
+
+class AuthControllerTest extends ApiTestCase
+{
+    use MailTrap;
+
+    public function test_login()
+    {
+        $credentials = [
+            'username' => 'foo',
+            'password' => 'bar'
+        ];
+
+        Carbon::setTestNow(Carbon::now());
+
+        $user = factory(User::class)->create($credentials);
+
+        $this->postJson("/api/login", $credentials);
+
+        $token = Token::where('user_id', $user->id)->first();
+
+        $this->assertJwtTokenContains($token->id);
+    }
+
+    public function test_login_with_invalid_credentials()
+    {
+        $credentials = [
+            'username' => 'foo',
+            'password' => 'bar'
+        ];
+
+        factory(User::class)->create($credentials);
+
+        $this->postJson("/api/login", [
+            'username' => 'foo',
+            'password' => 'invalid'
+        ]);
+
+        $this->assertResponseStatus(401);
+        $this->seeJsonContains([
+            'error' => "Invalid credentials."
+        ]);
+    }
+
+    public function test_login_when_credentials_are_not_provided()
+    {
+        $this->postJson("/api/login");
+
+        $this->assertResponseStatus(422);
+        $this->seeJsonContains([
+            'username' => [
+                trans('validation.required', ['attribute' => 'username'])
+            ],
+            'password' => [
+                trans('validation.required', ['attribute' => 'password'])
+            ]
+        ]);
+    }
+
+    public function test_logout()
+    {
+        $credentials = [
+            'username' => 'foo',
+            'password' => 'bar'
+        ];
+
+        Carbon::setTestNow(Carbon::now());
+
+        $user = factory(User::class)->create($credentials);
+
+        $this->postJson("/api/login", $credentials);
+
+        $token = Token::where('user_id', $user->id)->first();
+
+        $response = $this->decodeResponseJson();
+
+        $this->postJson("/api/logout", [], [
+            'Authorization' => "Bearer {$response['token']}"
+        ]);
+
+        $this->dontSeeInDatabase('api_tokens', ['id' => $token->id])
+            ->assertNull(auth('api')->user());
+    }
+
+    public function test_logout_if_token_is_not_provided()
+    {
+        $this->postJson("/api/logout");
+
+        $this->assertResponseStatus(401);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Auth/Password/RemindControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/Password/RemindControllerTest.php
new file mode 100644
index 0000000..4cb7132
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Auth/Password/RemindControllerTest.php
@@ -0,0 +1,57 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Auth\Password;
+
+use Carbon\Carbon;
+use Tests\Feature\ApiTestCase;
+use Tests\MailTrap;
+use Portal\Events\User\RequestedPasswordResetEmail;
+use Portal\Services\Auth\Api\Token;
+use Portal\User;
+
+class RemindControllerTest extends ApiTestCase
+{
+    use MailTrap;
+
+    public function test_send_password_reminder()
+    {
+        factory(User::class)->create(['email' => 'test@test.com']);
+
+//        $this->expectsEvents(RequestedPasswordResetEmail::class);
+
+        $this->postJson('api/password/remind', [
+            'email' => 'test@test.com'
+        ]);
+
+        $this->assertResponseOk();
+
+        $message = $this->fetchInbox()[0];
+
+        $this->assertEquals('test@test.com', $message['to_email']);
+        $this->assertEquals(config('mail.from.address'), $message['from_email']);
+        $this->assertEquals(config('mail.from.name'), $message['from_name']);
+        $this->assertContains(
+            trans('app.request_for_password_reset_made'),
+            $message['html_body']
+        );
+
+        $this->assertContains(
+            trans('app.if_you_did_not_requested'),
+            $message['html_body']
+        );
+
+        $this->emptyInbox();
+    }
+
+    public function test_password_reminder_with_wrong_email()
+    {
+        $this->postJson('api/password/remind', [
+            'email' => 'test@test.com'
+        ]);
+
+        $this->assertResponseStatus(422)
+            ->seeJsonEquals([
+                'email' => ['The selected email is invalid.']
+            ]);
+    }
+}
diff --git a/tests/Feature/Http/Controllers/Api/Auth/Password/ResetControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/Password/ResetControllerTest.php
new file mode 100644
index 0000000..b12fc4e
--- /dev/null
+++ b/tests/Feature/Http/Controllers/Api/Auth/Password/ResetControllerTest.php
@@ -0,0 +1,106 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers\Api\Auth\Password;
+
+use Carbon\Carbon;
+use DB;
+use Hash;
+use Illuminate\Support\Str;
+use Tests\Feature\ApiTestCase;
+use Tests\MailTrap;
+use Portal\User;
+
+class ResetControllerTest extends ApiTestCase
+{
+    use MailTrap;
+
+    public function test_password_reset()
+    {
+        $this->setSettings(['forgot_password' => true]);
+
+        $user = factory(User::class)->create([
+            'email' => 'test@test.com'
+        ]);
+
+        $token = $this->createNewToken();
+
+        DB::table('password_resets')->insert([
+            'email' => $user->email,
+            'token' => Hash::make($token),
+            'created_at' => Carbon::now()
+        ]);
+
+        $this->resetPassword($token, $user->email);
+
+        $this->assertResponseOk();
+
+        $user = $user->fresh();
+
+        $this->assertTrue(Hash::check('123123', $user->password));
+    }
+
+    public function test_password_reset_with_expired_token()
+    {
+        $this->setSettings(['forgot_password' => true]);
+
+        $user = factory(User::class)->create([
+            'email' => 'test@test.com'
+        ]);
+
+        $token = $this->createNewToken();
+
+        DB::table('password_resets')->insert([
+            'email' => $user->email,
+            'token' => Hash::make($token),
+            'created_at' => Carbon::now()->subHours(2)
+        ]);
+
+        $this->resetPassword($token, $user->email);
+
+        $this->seeJsonEquals([
+            'error' => "This password reset token is invalid."
+        ]);
+    }
+
+    public function test_password_reset_with_invalid_email()
+    {
+        $this->setSettings(['forgot_password' => true]);
+
+        $user = factory(User::class)->create(['email' => 'test@test.com']);
+
+        $token = $this->createNewToken();
+
+        DB::table('password_resets')->insert([
+            'email' => $user->email,
+            'token' => Hash::make($token),
+            'created_at' => Carbon::now()
+        ]);
+
+        $this->resetPassword($token, 'foo@bar.com');
+
+        $this->seeJsonContains([
+            'error' => "We can't find a user with that e-mail address."
+        ]);
+    }
+
+    private function resetPassword($token, $email)
+    {
+        $this->postJson('api/password/reset', [
+            'token' => $token,
+            'email' => $email,
+            'password' => '123123',
+            'password_confirmation' => '123123'
+        ]);
+    }
+
+    private function createNewToken()
+    {
+        $key = $this->app['config']['app.key'];
+
+        if (Str::startsWith($key, 'base64:')) {
+            $key = base64_decode(substr($key, 7));
+        }
+
+        return hash_hmac('sha256', Str::random(40), $key);
+    }
+}
